/*
 * SuppliersView.java
 *
 * Created on 10 de agosto de 2004, 17:55
 */

package com.fenalco.servlets.shopkeeper;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.Store;
import com.fenalco.entities.SupplierList;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.SupplierListViewShopKeeper;

/**
 * Este servlet carga la lista de proveedores del minorista a través de una
 * instancia de <CODE>SupplierList</CODE> y luego construye la vista que es
 * enviada a misproveedores.jsp como instancia de <CODE>SupplierListView
 * </CODE>
 * 
 * @author Mario Linares Vásquez
 */
public class SuppliersView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 * @throws ServletException
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destructor de el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Este método procesa las solicitudes para los métodos HTTP
	 * <code>GET</code> y <code>POST</code>. Crea una instancia de <CODE>
	 * SupplierList</CODE> con el id del minorista tomado del atributo <CODE>
	 * user</CODE> de la sesión, luego construye una instancia de <CODE>
	 * SupplierListView</CODE> que representa la vista de el listado. El
	 * listado es colocado en el <CODE>response</CODE> como atributo con
	 * nombre <CODE>view</CODE> y luego se redirecciona el flujo a
	 * misproveedores.jsp.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		String url = "/minorista/misproveedores.jsp";
		String message = "";

        HttpSession session = request.getSession( false );
	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 3 )
			{
				message = MessageBuilder.buildMessage(15);
				url = "/index.jsp";
			}
			else
			{
				User user = (User) request.getSession().getAttribute("user");
				Store store = (Store) request.getSession().getAttribute("store");
				int storeId = store.getId();
	
				SupplierList list = new SupplierList(storeId);
				SupplierListViewShopKeeper view = new SupplierListViewShopKeeper(
						list, user.getCompanyId());
	
				request.setAttribute("view", view);
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		RequestDispatcher dispatcher = getServletContext()
				.getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Procesa el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Procesa el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una breve description de el servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}